// DesktopPage.cpp : implementation file
//

#include "stdafx.h"
#include "RazerChromaSampleApplication.h"
#include "DesktopPage.h"
#include "HealthAmmoManaDlg.h"
#include "AlertDlg.h"
#include "AmbientEffectDlg.h"


// CDesktopPage

IMPLEMENT_DYNAMIC(CDesktopPage, CMFCPropertyPage)

CDesktopPage::CDesktopPage()
    : CMFCPropertyPage(CDesktopPage::IDD)
{

}

CDesktopPage::~CDesktopPage()
{
}


BEGIN_MESSAGE_MAP(CDesktopPage, CMFCPropertyPage)
    ON_BN_CLICKED(IDC_BUTTON_LOADING_ANIMATION, &CDesktopPage::OnBnClickedButtonLoadingAnimation)
    ON_BN_CLICKED(IDC_BUTTON_HEALTH_AMMO_MANA, &CDesktopPage::OnBnClickedButtonHealthAmmoMana)
    ON_BN_CLICKED(IDC_BUTTON_ALERTS, &CDesktopPage::OnBnClickedButtonAlerts)
    ON_BN_CLICKED(IDC_BUTTON_AMBIENT_EFFECT, &CDesktopPage::OnBnClickedButtonAmbientEffect)
    ON_BN_CLICKED(IDC_BUTTON_DAMAGE_TAKEN, &CDesktopPage::OnBnClickedButtonDamageTaken)
END_MESSAGE_MAP()


// CDesktopPage message handlers

void CDesktopPage::OnBnClickedButtonLoadingAnimation()
{
    static RZEFFECTID EffectId = GUID_NULL;

    if (EffectId == GUID_NULL)
    {
        const unsigned short MAX_ANIMATION_FRAMES = 11;
        RZEFFECTID StartFrame = GUID_NULL;
        RZEFFECTID AnimateFrames[MAX_ANIMATION_FRAMES] = {};
        RZEFFECTID EndFrame = GUID_NULL;

        ChromaSDK::Desktop::CUSTOM_EFFECT_TYPE Effect = {};

        g_ChromaSDKImpl.CreateEffectImpl(ChromaSDK::DESKTOP, ChromaSDK::CHROMA_NONE, NULL, &StartFrame);

        // 33 loops 
        for (auto i = 0; i < MAX_ANIMATION_FRAMES; i++)
        {
            for (auto r = 0; r < ChromaSDK::Desktop::MAX_ROW; r++)
            {
                for (auto c = (i * 3); c < ((i * 3) + 3); c++)
                {
                    Effect.Color[r][c] = ORANGE;

                    ATLASSERT(c < ChromaSDK::Desktop::MAX_COLUMN);
                }
            }

            g_ChromaSDKImpl.CreateEffectImpl(ChromaSDK::DESKTOP, ChromaSDK::CHROMA_CUSTOM, &Effect, &AnimateFrames[i]);
        }

        ChromaSDK::Desktop::STATIC_EFFECT_TYPE StaticEffect = {};
        StaticEffect.Color = ORANGE;

        g_ChromaSDKImpl.CreateEffectImpl(ChromaSDK::DESKTOP, ChromaSDK::CHROMA_STATIC, &StaticEffect, &EndFrame);

        g_ChromaSDKImpl.CreateEffectGroup(&EffectId);

        g_ChromaSDKImpl.AddToGroup(EffectId, StartFrame, 500);

        for (auto i = 0; i < MAX_ANIMATION_FRAMES; i++)
        {
            g_ChromaSDKImpl.AddToGroup(EffectId, AnimateFrames[i], 80);
        }

        g_ChromaSDKImpl.AddToGroup(EffectId, EndFrame, 80);
    }

    g_ChromaSDKImpl.SetEffectImpl(EffectId);
}


void CDesktopPage::OnBnClickedButtonHealthAmmoMana()
{
    CHealthAmmoManaDlg dlg(this);
    dlg.DoModal();
}


void CDesktopPage::OnBnClickedButtonAlerts()
{
    CAlertDlg dlg(this);
    dlg.DoModal();
}


void CDesktopPage::OnBnClickedButtonAmbientEffect()
{
    CAmbientEffectDlg dlg(this);
    dlg.DoModal();
}


void CDesktopPage::OnBnClickedButtonDamageTaken()
{
    static RZEFFECTID EffectId = GUID_NULL;
    if (IsEqualGUID(EffectId, GUID_NULL))
    {
        g_ChromaSDKImpl.CreateEffectGroup(&EffectId);

        RZEFFECTID Frame1 = GUID_NULL;
        RZEFFECTID Frame2 = GUID_NULL;

        ChromaSDK::Desktop::STATIC_EFFECT_TYPE Static = {};
        Static.Color = RED;

        g_ChromaSDKImpl.CreateEffectImpl(ChromaSDK::DESKTOP, ChromaSDK::CHROMA_STATIC, &Static, &Frame1);

        g_ChromaSDKImpl.AddToGroup(EffectId, Frame1, 50);

        g_ChromaSDKImpl.CreateEffectImpl(ChromaSDK::DESKTOP, ChromaSDK::CHROMA_NONE, NULL, &Frame2);

        g_ChromaSDKImpl.AddToGroup(EffectId, Frame2, 50);
    }

    g_ChromaSDKImpl.SetEffectImpl(EffectId);
}
